## shark 3.0.1%2Bds1

=== include/CMakeLists.txt ===
INSTALL( DIRECTORY
	 ${CMAKE_CURRENT_SOURCE_DIR}/shark
	 DESTINATION DESTINATION ${SHARK_INSTALL_INCLUDE_DIR}
	 PATTERN ".*" EXCLUDE
)

=== debian/changelog ===
shark (3.0.1+ds1-2ubuntu1) xenial; urgency=medium

  * Override testsuite for armhf i386 and powerpc,
    it has always failed there. 

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 06 Apr 2016 18:13:20 +0200

shark (3.0.1+ds1-2) unstable; urgency=medium

  * d/control: libshark-dev depends on libboost-dev.
  * d/tests/build-examples: build with Boost.
  * d/rules: fixup auto_test override.
  * Bump standards version to 3.9.7, no changes required.
  * libshark-dev: add missing install depends on blas and hdf5.
  * Fix build of examples in autopkgtest testsuite.
  * d/watch: fix filename mangling regex.
  * d/gbp.conf: change packaging branch to debian/master (DEP-14).

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Tue, 15 Mar 2016 18:57:50 +0000

shark (3.0.1+ds1-1) unstable; urgency=low

  * Initial release. (Closes: #595485)

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Thu, 26 Nov 2015 12:54:08 +0000

## shark 3.0.1+ds1

=== CMakeLists.txt ===
#####################################################################
#       Shark Machine Learning Library
#       Top-Level CMake driver file
#       Optionally included sub-probjects:
#         * Test/CMakeLists.txt
#         * examples/CMakeLists.txt
#         * doc/CMakeLists.txt
#####################################################################
project( shark )

set_property(GLOBAL PROPERTY USE_FOLDERS ON)
INCLUDE (CheckFunctionExists)

cmake_minimum_required( VERSION 2.8 )
cmake_policy(SET CMP0003 NEW)
if(POLICY CMP0042)
	cmake_policy(SET CMP0042 NEW)
endif()
if(POLICY CMP0053)
	cmake_policy(SET CMP0053 NEW)
endif()
#=========================================================
# Output directories.
if(NOT CMAKE_RUNTIME_OUTPUT_DIRECTORY)
	set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${shark_BINARY_DIR}/bin")
endif()
if(NOT CMAKE_LIBRARY_OUTPUT_DIRECTORY)
	if(UNIX)
		set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${shark_BINARY_DIR}/lib")
	else()
		set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${shark_BINARY_DIR}/bin")
	endif()
endif()
if(NOT CMAKE_ARCHIVE_OUTPUT_DIRECTORY)
	set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${shark_BINARY_DIR}/lib")
endif()
mark_as_advanced( 
	CMAKE_RUNTIME_OUTPUT_DIRECTORY
	CMAKE_LIBRARY_OUTPUT_DIRECTORY
	CMAKE_ARCHIVE_OUTPUT_DIRECTORY
)

#####################################################################
# Static/Shared libraries
#####################################################################
option(BUILD_SHARED_LIBS "Compile shark into a dynamic library instead of a static one." OFF)
if(BUILD_SHARED_LIBS)
	set(SHARK_USE_DYNLIB 1)
endif()

#####################################################################
# Version information
#####################################################################
option(BUILD_OFFICIAL_RELEASE "Is this an official Shark release." OFF )
mark_as_advanced( BUILD_OFFICIAL_RELEASE )

set(SHARK_VERSION_MAJOR 3)
set(SHARK_VERSION_MINOR 0)
set(SHARK_VERSION_PATCH 0)
set(SHARK_VERSION ${SHARK_VERSION_MAJOR}.${SHARK_VERSION_MINOR}.${SHARK_VERSION_PATCH})
set(SHARK_SOVERSION 0)


#####################################################################
#	Adjustments for cpack and deb package generation
#####################################################################
set(CPACK_GENERATOR TGZ DEB)
set(CPACK_PACKAGE_NAME "libshark")
set(CPACK_BUNDLE_NAME "libshark")
set(CPACK_PACKAGE_VENDOR "Institut fur Neuroinformatik, Ruhr-Universitaet Bochum")
set(CPACK_PACKAGE_VERSION_MAJOR ${SHARK_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${SHARK_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${SHARK_VERSION_PATCH})
set(CPACK_PACKAGE_VERSION ${SHARK_VERSION_MAJOR}.${SHARK_VERSION_MINOR}.${SHARK_VERSION_PATCH})
set(CPACK_RESOURCE_FILE_LICENSE ${CMAKE_CURRENT_SOURCE_DIR}/COPYING.LESSER)

#Debian Compatible naming by default
if(CMAKE_SIZEOF_VOID_P MATCHES "8")
	set(CPACK_DEBIAN_PACKAGE_ARCHITECTURE amd64)
else()
	set(CPACK_DEBIAN_PACKAGE_ARCHITECTURE i386)
endif()
set(CPACK_PACKAGE_FILE_NAME ${CPACK_PACKAGE_NAME}_${CPACK_PACKAGE_VERSION}_${CPACK_DEBIAN_PACKAGE_ARCHITECTURE})
set(CPACK_DEBIAN_PACKAGE_DEPENDS "libboost-all-dev (>=1.54)")

set(CPACK_DEBIAN_PACKAGE_DESCRIPTION
	"SHARK is a modular C++ library for the design and optimization of adaptive systems. It provides methods for linear and nonlinear optimization, in particular evolutionary and gradient-based algorithms, kernel-based learning algorithms and neural networks, and various other machine learning techniques. SHARK serves as a toolbox to support real world applications as well as research indifferent domains of computational intelligence and machine learning. The sources are compatible with the following platforms: Windows, Solaris, MacOS X, and Linux."
)
set( CPACK_DEBIAN_PACKAGE_MAINTAINER "Christian Igel <c.igel@ieee.org>" )

#####################################################################
#    Adjust include, lib, example and doc paths for installation
#####################################################################
if( UNIX )
	set( SHARK_INSTALL_INCLUDE_DIR include/ )
	set( SHARK_INSTALL_LIB_DIR lib/ )
	set( SHARK_INSTALL_CONTRIB_DIR share/shark/contrib/ )
	set( SHARK_INSTALL_EXAMPLE_DIR share/shark/examples/ )
	set( SHARK_INSTALL_DOC_DIR share/shark/doc/ )
else()
	set( SHARK_INSTALL_INCLUDE_DIR include/shark/ )
	set( SHARK_INSTALL_LIB_DIR lib/ )
	set( SHARK_INSTALL_CONTRIB_DIR contrib/ )
	set( SHARK_INSTALL_EXAMPLE_DIR examples/ )
	set( SHARK_INSTALL_DOC_DIR doc )
endif()

#####################################################################
#           Enable installer and package generation
#####################################################################
 include( CPack )

#####################################################################
#           Explicit macro setup for debug configuration
#####################################################################
# enable or disable debugging, default is Release
if(NOT CMAKE_BUILD_TYPE)
	set(CMAKE_BUILD_TYPE "Release")
endif()

if (UNIX)
    add_compile_options("$<$<CONFIG:DEBUG>:-Wall>")
endif()

list(APPEND COMPILE_DEFINITIONS_RELEASE NDEBUG)
message(STATUS "Will build: " ${CMAKE_BUILD_TYPE})

#####################################################################
#           Boost configuration
#####################################################################
set(Boost_USE_STATIC_LIBS OFF CACHE BOOL "use static libraries from Boost")
set(Boost_USE_MULTITHREADED ON)
add_definitions(-DBOOST_PARAMETER_MAX_ARITY=15)
add_definitions(-DBOOST_FILESYSTEM_VERSION=3)

# Should we link the boost test dynamically
if(NOT Boost_USE_STATIC_LIBS)
	add_definitions(-DBOOST_TEST_DYN_LINK)
	add_definitions(-DBOOST_ALL_DYN_LINK)
endif()

find_package( 
	Boost 1.48.0 REQUIRED COMPONENTS
	system date_time filesystem
	program_options serialization thread
	unit_test_framework
)

if(NOT Boost_FOUND)
	message(FATAL_ERROR "Please make sure Boost 1.48.0 is installed on your system")
endif()

if (WIN32)
	# disable autolinking in boost
	add_definitions( -DBOOST_ALL_NO_LIB )
endif()

include_directories(SYSTEM ${Boost_INCLUDE_DIR} )
link_directories( ${Boost_LIBRARY_DIR} )
if(UNIX)
	find_library( PTHREAD_LIBRARY pthread )
endif()

# Set the libraries needed by Shark
list(APPEND LINK_LIBRARIES ${Boost_LIBRARIES} ${PTHREAD_LIBRARY})

mark_as_advanced(Boost_DIR PTHREAD_LIBRARY)
message( STATUS "Using boost from " ${Boost_LIBRARY_DIR} )

#####################################################################
#		OpenMP
#####################################################################
option( ENABLE_OPENMP "Enable OpenMP" ON )
if( ENABLE_OPENMP )
	find_package( OpenMP QUIET )
	if( OPENMP_FOUND )
		message( STATUS "OpenMP found" )
		set(SHARK_USE_OPENMP 1)
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
		set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${OpenMP_EXE_LINKER_FLAGS}")

		set(SHARK_REQUIRED_C_FLAGS "${OpenMP_C_FLAGS}")
		set(SHARK_REQUIRED_CXX_FLAGS "${OpenMP_CXX_FLAGS}")
		set(SHARK_REQUIRED_EXE_LINKER_FLAGS "${OpenMP_EXE_LINKER_FLAGS}")

	else()
		message( STATUS "OpenMP not found" )
	endif()
else()
	message( STATUS "Building without OpenMP as requested." )
endif()

#####################################################################
#           HDF5 configuration
#####################################################################
find_package(HDF5 COMPONENTS C CXX HL QUIET)
mark_as_advanced(HDF5_DIR)
if(HDF5_FOUND)
	if(HDF5_C_COMPILER_EXECUTABLE AND HDF5_CXX_COMPILER_EXECUTABLE)
		message(STATUS "Checking HDF5 installation: HDF5 installation seems ok.")
		include_directories( ${HDF5_INCLUDE_DIR} )
		link_directories( ${HDF5_LIBRARY_DIR} )
		list(APPEND LINK_LIBRARIES ${HDF5_LIBRARIES})
	else()
		message(STATUS "Checking HDF5 installation:HDF5 package might be broken.")
		if(NOT( HDF5_C_COMPILER_EXECUTABLE))
			message(STATUS "  C Compiler Extension not found.")
		endif()
		if(NOT( HDF5_CXX_COMPILER_EXECUTABLE))
			message(STATUS "  CXX Compiler Extension not found.")
		endif()
			message(STATUS "Disabling HDF5.")
		unset( HDF5_FOUND )
	endif()
else()
	message(STATUS "HDF5 not found, skip")
endif()

#####################################################################
#           ATLAS configuration
#####################################################################


option( ENABLE_CBLAS "Use Installed Linear Algebra Library" ON )

if( ENABLE_CBLAS )
	set(CBLAS_VENDOR FALSE)
	if( APPLE )
		set(CBLAS_VENDOR "Accelerate")
		set(CBLAS_INCLUDES "")
		set(CBLAS_LIBRARIES "-framework Accelerate" )
	else()
		#todo: do a propper vendor check
		find_library(OPENBLAS_LIBRARY openblas
			HINTS ${CBLAS_ROOT}/lib /opt/local/lib
		)
		find_library(CBLAS_LIBRARY cblas
			HINTS ${ATLAS_ROOT}/lib ${CBLAS_ROOT}/lib /opt/local/lib /usr/lib64/atlas/
		)
		find_library(CLAPACK_LIBRARY lapack
			HINTS ${ATLAS_ROOT}/lib ${CBLAS_ROOT}/lib /opt/local/lib /usr/lib64/atlas/
		)
		find_library(ATLAS_LIBRARY atlas
			HINTS ${ATLAS_ROOT}/lib ${CBLAS_ROOT}/lib /opt/local/lib /usr/lib64/atlas/
		)
		mark_as_advanced(
			OPENBLAS_LIBRARY
			CBLAS_LIBRARY
			CLAPACK_LIBRARY
			ATLAS_LIBRARY
		)
		#find the cblas.h include path
		if(CBLAS_LIBRARY )
			get_filename_component(CBLAS_LIB_PATH ${CBLAS_LIBRARY} PATH )
		elseif( OPENBLAS_LIBRARY)	
			get_filename_component(CBLAS_LIB_PATH ${OPENBLAS_LIBRARY} PATH )
		endif()
		if(CBLAS_LIB_PATH)
			find_file(CBLAS_INCLUDES cblas.h 
				PATHS ${CBLAS_LIB_PATH} ${CBLAS_LIB_PATH}/../include ${CBLAS_LIB_PATH}/../../include/atlas
			)
			get_filename_component(CBLAS_INCLUDES ${CBLAS_INCLUDES} PATH )
		endif()

		if( OPENBLAS_LIBRARY AND CBLAS_INCLUDES)
			set(CBLAS_VENDOR "OpenBLAS")
			set(CBLAS_LIBRARIES ${OPENBLAS_LIBRARY})
		elseif( CBLAS_LIBRARY AND CLAPACK_LIBRARY AND ATLAS_LIBRARY AND CBLAS_INCLUDES)
			set(CBLAS_VENDOR "ATLAS")
			set(CBLAS_LIBRARIES ${CLAPACK_LIBRARY} ${CBLAS_LIBRARY} ${ATLAS_LIBRARY})
		elseif( CBLAS_LIBRARY AND CBLAS_INCLUDES)
			#check that we can compile a basic program with the libraries we have found
			#vendor versions might come with additional libraries which would be bad.
			try_compile(CBLAS_COMPILE 
				"${PROJECT_BINARY_DIR}/cBlasCheck"
				"${CMAKE_SOURCE_DIR}/cBlasCheck.cpp"
				CMAKE_FLAGS "-DINCLUDE_DIRECTORIES=${CBLAS_INCLUDES}"
				LINK_LIBRARIES ${CBLAS_LIBRARY}
			)
			if(CBLAS_COMPILE)
				set(CBLAS_VENDOR "GENERIC")
				set(CBLAS_LIBRARIES ${CBLAS_LIBRARY})
			else()
				message(WARNING "Unknown CBLAS. Can not use it")
			endif()
		endif()
	endif()
	
	if(CBLAS_VENDOR)
		message(STATUS "CBLAS FOUND: " ${CBLAS_VENDOR} " with include directory " ${CBLAS_INCLUDES} )
		set(SHARK_USE_CBLAS 1)
		list(APPEND EXTRA_INCLUDE_DIRECTORIES ${CBLAS_INCLUDES} )
		list(APPEND LINK_LIBRARIES ${CBLAS_LIBRARIES})
		include_directories ( ${CBLAS_INCLUDES} )
	else()
		message(STATUS "No usable CBLAS Library found. No fast linear Algebra used.")
	endif()
	
	#Special setup for ATLAS
	if( CBLAS_VENDOR MATCHES "ATLAS" )
		set( SHARK_USE_ATLAS_LAPACK 1) # ATLAS always contains some LAPACK methods that we can use
		
		#check for full lapack
		set(CMAKE_REQUIRE_QUIET 1)
		set(CMAKE_REQUIRED_LIBRARIES ${CBLAS_LIBRARIES})
		check_function_exists(dsyev_ ATLAS_FULL_LAPACK)
		
		if( ATLAS_FULL_LAPACK )
			set( SHARK_USE_LAPACK 1)
			message(STATUS "Detected ATLAS with full LAPACK package. Using it!")
		endif()
	endif()
endif()
#####################################################################
#                       Static Code Analysis
#####################################################################
option(USE_CPPCHECK "Use CPPCheck Static Code Analysis" OFF)
mark_as_advanced(USE_CPPCHECK)
if(USE_CPPCHECK)
	find_program(CPP_CHECK cppcheck)
	mark_as_advanced(CPP_CHECK)
if(CPP_CHECK)
	message(STATUS "cppcheck available for static code analysis." )
	add_custom_target(code_analysis
		${CPP_CHECK} --enable=all --xml --force -I${CMAKE_CURRENT_SOURCE_DIR}/include ${CMAKE_CURRENT_SOURCE_DIR} 2> StaticAnalysis.xml)
	endif()

=== Test/CMakeLists.txt ===
#####################################################################
#       Shark Machine Learning Library                              #
#       Setup for unit testing                                      #
#       Test invocation: CTest                                      #
#       Test implementation: Boost UTF                              #
#####################################################################


#####################################################################
#       Configure logging of test restuls to XML                    #
#####################################################################
option( LOG_TEST_OUTPUT "Log test output to XML files." OFF )

#####################################################################
#   Adds a unit test for the shark library                          #
#   Param: SRC Source files for compilation                         #
#   Param: NAME Target name for the resulting executable            #
#   Output: Executable in ${SHARK}/Test/bin                         #
#                                                                   #
#       If OPT_LOG_TEST_OUTPUT is enabled, test log is written      #
#   to ${NAME_Log.xml} in ${SHARK}/Test/bin.                        #
#####################################################################
macro(SHARK_ADD_TEST SRC NAME)
   
  if( OPT_LOG_TEST_OUTPUT )
    set( XML_LOGGING_COMMAND_LINE_ARGS "--log_level=test_suite --log_format=XML --log_sink=${NAME}_Log.xml --report_level=no" )
  endif( OPT_LOG_TEST_OUTPUT )

  # Create the test executable
  add_executable( ${NAME} ${SRC} Models/derivativeTestHelper.h )
  target_link_libraries( ${NAME} shark)

  if(GCOV_CHECK)
    target_link_libraries( ${NAME} gcov)
  endif (GCOV_CHECK)

  # Add the test
  add_test( ${NAME} ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${NAME} ${XML_LOGGING_COMMAND_LINE_ARGS} )

  set_target_properties(${NAME} PROPERTIES FOLDER "Tests")
  if(GCOV_CHECK)
    add_Test( ${NAME} ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${NAME} ${XML_LOGGING_COMMAND_LINE_ARGS} COMMAND Coverage)
  endif (GCOV_CHECK)
endmacro()

# BLAS Tests
shark_add_test( LinAlg/BLAS/iterators.cpp BLAS_Iterators)
shark_add_test( LinAlg/BLAS/vector_assign.cpp BLAS_Vector_Assign)
shark_add_test( LinAlg/BLAS/matrix_assign.cpp BLAS_Matrix_Assign)
shark_add_test( LinAlg/BLAS/compressed_vector.cpp BLAS_Compressed_Vector)
shark_add_test( LinAlg/BLAS/triangular_matrix.cpp BLAS_Triangular_Matrix)
shark_add_test( LinAlg/BLAS/compressed_matrix.cpp BLAS_Compressed_Matrix)
shark_add_test( LinAlg/BLAS/vector_proxy.cpp BLAS_Vector_Proxy)
shark_add_test( LinAlg/BLAS/matrix_proxy.cpp BLAS_Matrix_Proxy)
shark_add_test( LinAlg/BLAS/vector_expression.cpp BLAS_Vector_Expression)
shark_add_test( LinAlg/BLAS/axpy_prod.cpp BLAS_Axpy_Prod)
shark_add_test( LinAlg/BLAS/triangular_prod.cpp BLAS_Triangular_Prod)

# LinAlg Tests
shark_add_test( LinAlg/DiagonalMatrix.cpp LinAlg_DiagonalMatrix)
shark_add_test( LinAlg/sumRows.cpp LinAlg_SumRows)
shark_add_test( LinAlg/Proxy.cpp LinAlg_Proxy )
shark_add_test( LinAlg/repeat.cpp LinAlg_Repeat)
shark_add_test( LinAlg/rotations.cpp LinAlg_rotations )
shark_add_test( LinAlg/permute.cpp LinAlg_Permutations )
shark_add_test( LinAlg/KernelMatrix.cpp LinAlg_KernelMatrix )
shark_add_test( LinAlg/Metrics.cpp LinAlg_Metrics)
shark_add_test( LinAlg/RQ.cpp LinAlg_RQ )
shark_add_test( LinAlg/eigensymm.cpp LinAlg_eigensymm )
shark_add_test( LinAlg/svd.cpp LinAlg_svd )
shark_add_test( LinAlg/choleskyDecomposition.cpp LinAlg_choleskyDecomposition)
shark_add_test( LinAlg/solve.cpp LinAlg_solve)
shark_add_test( LinAlg/BLAS/transformations.cpp BLAS_Transformations)
shark_add_test( LinAlg/Initialize.cpp LinAlg_Initialize)
shark_add_test( LinAlg/LRUCache.cpp LinAlg_LRUCache )
shark_add_test( LinAlg/PartlyPrecomputedMatrix.cpp LinAlg_PartlyPrecomputedMatrix )

#Algorithms tests 
#Direct Search
shark_add_test( Algorithms/DirectSearch/CMA.cpp DirectSearch_CMA )
shark_add_test( Algorithms/DirectSearch/CMSA.cpp DirectSearch_CMSA )
shark_add_test( Algorithms/DirectSearch/ElitistCMA.cpp DirectSearch_ElitistCMA )
shark_add_test( Algorithms/DirectSearch/VDCMA.cpp DirectSearch_VDCMA )
shark_add_test( Algorithms/DirectSearch/MOCMA.cpp DirectSearch_MOCMA )
shark_add_test( Algorithms/DirectSearch/SteadyStateMOCMA.cpp DirectSearch_SteadyStateMOCMA )
shark_add_test( Algorithms/DirectSearch/RealCodedNSGAII.cpp DirectSearch_RealCodedNSGAII )
shark_add_test( Algorithms/DirectSearch/FastNonDominatedSort.cpp DirectSearch_FastNonDominatedSort )
shark_add_test( Algorithms/DirectSearch/ParetoDominanceComparator.cpp DirectSearch_ParetoDominanceComparator )

# Direct Search Operator tests
shark_add_test( Algorithms/DirectSearch/Operators/Selection/Selection.cpp DirectSearch_Selection )
shark_add_test( Algorithms/DirectSearch/Operators/Selection/IndicatorBasedSelection.cpp DirectSearch_IndicatorBasedSelection )
shark_add_test( Algorithms/DirectSearch/Operators/Mutation/BitflipMutation.cpp DirectSearch_BitflipMutation )
shark_add_test( Algorithms/DirectSearch/Operators/PenalizingEvaluator.cpp DirectSearch_PenalizingEvaluator )

# Direct Search Indicator tests
shark_add_test( Algorithms/DirectSearch/Indicators/HypervolumeIndicator.cpp DirectSearch_HypervolumeIndicator )

# GradientDescent
shark_add_test( Algorithms/GradientDescent/LineSearch.cpp GradDesc_LineSearch )
shark_add_test( Algorithms/GradientDescent/BFGS.cpp GradDesc_BFGS )
shark_add_test( Algorithms/GradientDescent/LBFGS.cpp GradDesc_LBFGS )
shark_add_test( Algorithms/GradientDescent/CG.cpp GradDesc_CG )
shark_add_test( Algorithms/GradientDescent/Rprop.cpp GradDesc_Rprop )
shark_add_test( Algorithms/GradientDescent/SteepestDescent.cpp GradDesc_SteepestDescent )


# Trainers
shark_add_test( Algorithms/Trainers/CSvmTrainer.cpp Trainers_CSvmTrainer )
shark_add_test( Algorithms/Trainers/FisherLDA.cpp Trainers_FisherLDA )
shark_add_test( Algorithms/Trainers/KernelMeanClassifier.cpp Trainers_KernelMeanClassifier )
shark_add_test( Algorithms/Trainers/EpsilonSvmTrainer.cpp Trainers_EpsilonSvmTrainer )
shark_add_test( Algorithms/Trainers/OneClassSvmTrainer.cpp Trainers_OneClassSvmTrainer )
shark_add_test( Algorithms/Trainers/RegularizationNetworkTrainer.cpp Trainers_RegularizationNetworkTrainer )
shark_add_test( Algorithms/Trainers/LDA.cpp Trainers_LDA )
shark_add_test( Algorithms/Trainers/LinearRegression.cpp Trainers_LinearRegression )
shark_add_test( Algorithms/Trainers/McSvmTrainer.cpp Trainers_McSvmTrainer )
shark_add_test( Algorithms/Trainers/LinearSvmTrainer.cpp Trainers_LinearSvmTrainer )
shark_add_test( Algorithms/Trainers/NBClassifierTrainerTests.cpp Trainers_NBClassifier )
shark_add_test( Algorithms/Trainers/Normalization.cpp Trainers_Normalization )
shark_add_test( Algorithms/Trainers/KernelNormalization.cpp Trainers_KernelNormalization )
shark_add_test( Algorithms/Trainers/SigmoidFit.cpp Trainers_SigmoidFit )
shark_add_test( Algorithms/Trainers/PCA.cpp Trainers_PCA )
shark_add_test( Algorithms/Trainers/Perceptron.cpp Trainers_Perceptron )
shark_add_test( Algorithms/Trainers/MissingFeatureSvmTrainerTests.cpp Trainers_MissingFeatureSvmTrainer )
shark_add_test( Algorithms/Trainers/Budgeted/AbstractBudgetMaintenanceStrategy_Test.cpp Trainers_AbstractBudgetMaintenanceStrategy )
shark_add_test( Algorithms/Trainers/Budgeted/MergeBudgetMaintenanceStrategy_Test.cpp MergeBudgetMaintenanceStrategy )
shark_add_test( Algorithms/Trainers/Budgeted/RemoveBudgetMaintenanceStrategy_Test.cpp RemoveBudgetMaintenanceStrategy )
shark_add_test( Algorithms/Trainers/Budgeted/KernelBudgetedSGDTrainer_Test.cpp KernelBudgetedSGDTrainer )

# Misc algorithms
shark_add_test( Algorithms/GridSearch.cpp Algorithms_GridSearch )
shark_add_test( Algorithms/Hypervolume.cpp Algorithms_Hypervolume )
shark_add_test( Algorithms/nearestneighbors.cpp Algorithms_NearestNeighbor )
shark_add_test( Algorithms/KMeans.cpp Algorithms_KMeans )
shark_add_test( Algorithms/JaakkolaHeuristic.cpp Algorithms_JaakkolaHeuristic )

# Models
shark_add_test( Models/ConcatenatedModel.cpp Models_ConcatenatedModel )
shark_add_test( Models/FFNet.cpp Models_FFNet )
shark_add_test( Models/Autoencoder.cpp Models_Autoencoder )
shark_add_test( Models/TiedAutoencoder.cpp Models_TiedAutoencoder )
shark_add_test( Models/LinearModel.cpp Models_LinearModel )
shark_add_test( Models/LinearNorm.cpp Models_LinearNorm )
shark_add_test( Models/ConvexCombination.cpp Models_ConvexCombination )
shark_add_test( Models/NBClassifierTests.cpp Models_NBClassifier )
#shark_add_test( Models/OnlineRNNet.cpp Models_OnlineRNNet )
shark_add_test( Models/RBFLayer.cpp Models_RBFLayer ) 
shark_add_test( Models/RNNet.cpp Models_RNNet ) 
shark_add_test( Models/CMAC.cpp Models_CMAC )
shark_add_test( Models/MeanModel.cpp Models_MeanModel )

shark_add_test( Models/SigmoidModel.cpp Models_SigmoidModel )
shark_add_test( Models/Softmax.cpp Models_Softmax )
shark_add_test( Models/SoftNearestNeighborClassifier.cpp Models_SoftNearestNeighborClassifier )
shark_add_test( Models/Kernels/KernelExpansion.cpp Models_KernelExpansion )
shark_add_test( Models/NearestNeighborRegression.cpp Models_NearestNeighborRegression )
shark_add_test( Models/OneVersusOneClassifier.cpp Models_OneVersusOneClassifier )

# Kernels
shark_add_test( Models/Kernels/GaussianRbfKernel.cpp Models_GaussianKernel )
shark_add_test( Models/Kernels/LinearKernel.cpp Models_LinearKernel )
shark_add_test( Models/Kernels/NormalizedKernel.cpp Models_NormalizedKernel )
shark_add_test( Models/Kernels/MonomialKernel.cpp Models_MonomialKernel )
shark_add_test( Models/Kernels/PolynomialKernel.cpp Models_PolynomialKernel )
shark_add_test( Models/Kernels/ScaledKernel.cpp Models_ScaledKernel )
shark_add_test( Models/Kernels/WeightedSumKernel.cpp Models_WeightedSumKernel )
shark_add_test( Models/Kernels/ProductKernel.cpp Models_ProductKernel )
shark_add_test( Models/Kernels/ArdKernel.cpp Models_ArdKernel )
shark_add_test( Models/Kernels/MklKernel.cpp Models_MklKernel )
shark_add_test( Models/Kernels/SubrangeKernel.cpp Models_SubrangeKernel )
shark_add_test( Models/Kernels/DiscreteKernel.cpp Models_DiscreteKernel )
shark_add_test( Models/Kernels/MultiTaskKernel.cpp Models_MultiTaskKernel )
shark_add_test( Models/Kernels/ModelKernel.cpp Models_ModelKernel )

# KernelMethods
shark_add_test( Models/Kernels/KernelHelpers.cpp Models_KernelHelpers )
shark_add_test( Models/Kernels/KernelNearestNeighborClassifier.cpp Models_KernelNearestNeighborClassifier )
shark_add_test( Models/Kernels/KernelNearestNeighborRegression.cpp Models_KernelNearestNeighborRegression )
shark_add_test( Models/Kernels/EvalSkipMissingFeaturesTests.cpp Models_EvalSkipMissingFeatures )
shark_add_test( Models/Kernels/MissingFeaturesKernelExpansionTests.cpp Models_MissingFeaturesKernelExpansion )
shark_add_test( Models/Kernels/CSvmDerivative.cpp Models_CSvmDerivative )

# Trees
shark_add_test( Models/RFClassifier.cpp Models_RFClassifier )
shark_add_test( Models/CARTClassifier.cpp Models_CARTClassifier )

# Core tests
#shark_add_test( Core/ScopedHandleTests.cpp Core_ScopedHandleTests )
shark_add_test( Core/Iterators.cpp Core_Iterators )
shark_add_test( Core/Math.cpp Core_Math )

# Data Tests
shark_add_test( Data/Csv.cpp Data_Csv )
shark_add_test( Data/Bootstrap.cpp Data_Bootstrap )
shark_add_test( Data/CVDatasetTools.cpp Data_CVDatasetTools )
shark_add_test( Data/Dataset.cpp Data_Dataset )
shark_add_test( Data/DataView.cpp Data_DataView )
shark_add_test( Data/LabelOrder_Test.cpp Data_LabelOrder )
shark_add_test( Data/Statistics.cpp Data_Statistics )
if(HDF5_FOUND)
  shark_add_test( Data/HDF5Tests.cpp Data_HDF5 )
endif()
shark_add_test( Data/SparseData.cpp Data_SparseData )
shark_add_test( Data/ExportKernelMatrix.cpp Data_ExportKernelMatrix )

#Objective Functions
shark_add_test( ObjectiveFunctions/ErrorFunction.cpp ObjFunct_ErrorFunction )
shark_add_test( ObjectiveFunctions/SparseAutoencoderError.cpp ObjFunct_SparseAutoencoderError )

=== doc/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED( VERSION 2.8 )

find_package( Doxygen REQUIRED )
find_package( PythonInterp REQUIRED )

ADD_SUBDIRECTORY(tutToRst)

CONFIGURE_FILE (
  "${CMAKE_CURRENT_SOURCE_DIR}/Shark.dox.in"
  "${CMAKE_CURRENT_BINARY_DIR}/Shark.dox"
)

CONFIGURE_FILE (
  "${CMAKE_CURRENT_SOURCE_DIR}/sphinx_pages/conf.py.in"
  "${CMAKE_CURRENT_SOURCE_DIR}/sphinx_pages/conf.py"
)

set( SPHINX_EXECUTABLE sphinx-build )
set( SPHINX_PARAMETERS -b html )

add_custom_target(doc_creation)

#find all .tut files
file(GLOB_RECURSE TutFiles sphinx_pages *.tut)
foreach(tut ${TutFiles})
	GET_FILENAME_COMPONENT(tutPath ${tut} PATH)
	GET_FILENAME_COMPONENT(tutName ${tut} NAME_WE)
	add_custom_command(TARGET doc_creation POST_BUILD COMMAND
		tut2rst ${tutPath}/${tutName} ${PROJECT_SOURCE_DIR}/examples
	)
endforeach()
add_dependencies(doc_creation tut2rst)
add_dependencies(tut2rst tpp2cpp)   # defined in examples folder

add_custom_target( doc ALL
	COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Shark.dox
	COMMAND ${SPHINX_EXECUTABLE} ${SPHINX_PARAMETERS} ${CMAKE_CURRENT_SOURCE_DIR}/sphinx_pages ${CMAKE_CURRENT_BINARY_DIR}/sphinx_pages/build/html
)
add_custom_command(TARGET doc PRE_BUILD
	COMMAND ${CMAKE_COMMAND} -E copy
		${CMAKE_CURRENT_SOURCE_DIR}/doxygen_pages/css/besser.css
		${CMAKE_CURRENT_BINARY_DIR}/doxygen_pages/css/besser.css )


add_dependencies(doc doc_creation)

OPTION( OPT_INSTALL_DOCUMENTATION "Install documentation." OFF )

IF( OPT_INSTALL_DOCUMENTATION )

INSTALL( FILES index.html
	DESTINATION ${SHARK_INSTALL_DOC_DIR}
)

INSTALL( DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/doxygen_pages
	DESTINATION ${SHARK_INSTALL_DOC_DIR}
	PATTERN ".*" EXCLUDE
)

INSTALL( DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/doxygen_pages/css
	DESTINATION ${SHARK_INSTALL_DOC_DIR}/doxygen_pages
	PATTERN ".*" EXCLUDE
)

INSTALL( DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/sphinx_pages
	DESTINATION ${SHARK_INSTALL_DOC_DIR}
	PATTERN ".*" EXCLUDE
)

ENDIF( OPT_INSTALL_DOCUMENTATION )

=== examples/CMakeLists.txt ===
#####################################################################
#		Shark Machine Learning Library
#		Setup for example compilation
#####################################################################

add_custom_target(sharkexamples)
set(EXAMPLES_CPP_DIR ${CMAKE_CURRENT_BINARY_DIR})
set(TPP_FILES "")

macro( SHARK_ADD_EXAMPLE TUT_SRC NAME COMPONENT )
	# Generate cpp file from tpp file
	add_custom_command(
	OUTPUT ${EXAMPLES_CPP_DIR}/${TUT_SRC}.cpp
	COMMAND ${CMAKE_COMMAND}
	ARGS
		-DTUT_TPP:Filepath=${CMAKE_CURRENT_SOURCE_DIR}/${TUT_SRC}.tpp
		-DTUT_CPP:Filepath=${EXAMPLES_CPP_DIR}/${TUT_SRC}.cpp
		-P ${CMAKE_CURRENT_SOURCE_DIR}/createExampleSource.cmake
	MAIN_DEPENDENCY
		${CMAKE_CURRENT_SOURCE_DIR}/${TUT_SRC}.tpp
	COMMENT "creating ${EXAMPLES_CPP_DIR}/${TUT_SRC}.cpp from ${CMAKE_CURRENT_SOURCE_DIR}/${TUT_SRC}.tpp"
	)

	list(APPEND TPP_FILES ${EXAMPLES_CPP_DIR}/${TUT_SRC}.cpp)

	if( BUILD_EXAMPLES )
		add_executable(${NAME} ${EXAMPLES_CPP_DIR}/${TUT_SRC}.cpp)
		target_link_libraries(${NAME} shark)

		# Add the dependencies to the target examples
		add_dependencies(sharkexamples ${NAME})

		set_target_properties( ${NAME} PROPERTIES FOLDER "examples")

		# Installation
		install(TARGETS ${NAME}
			   RUNTIME DESTINATION ${SHARK_INSTALL_EXAMPLE_DIR}/${COMPONENT}/
			   COMPONENT EXAMPLES)

		install(FILES ${EXAMPLES_CPP_DIR}/${TUT_SRC}.cpp
			   DESTINATION ${SHARK_INSTALL_EXAMPLE_DIR}/${COMPONENT})

		source_group(${COMPONENT} FILES ${TUT_SRC})
	endif()
endmacro()

shark_add_example( EA/MOO/AdditiveEpsilonIndicatorMain AdditiveEpsilonIndicatorMain "EA/MOO" )
#shark_add_example( EA/MOO/ApproximatedHypervolumeMain ApproximatedHypervolumeMain "EA/MOO" )
#shark_add_example( EA/MOO/ExactHypervolumeMain ExactHypervolumeMain "EA/MOO" )
##shark_add_example( EA/MOO/BoundingBoxCalculatorMain BoundingBoxCalculatorMain "EA/MOO" )

shark_add_example( EA/MOO/MOCMASimple MOCMASimple "EA/MOO" )
shark_add_example( EA/MOO/MOCMAExperiment MOCMAExperiment "EA/MOO" )

shark_add_example( EA/SOO/CMASimple CMASimple "EA/SOO" )
shark_add_example( EA/SOO/CMAExperiment CMAExperiment "EA/SOO" )
shark_add_example( EA/SOO/CMAPlot CMAPlot "EA/SOO" )
shark_add_example( EA/SOO/ElitistCMASimple ElitistCMASimpleMain "EA/SOO" )
shark_add_example( EA/SOO/TSP TSP "EA/SOO" )
shark_add_example( EA/SOO/AckleyES AckleyES "EA/SOO" )
shark_add_example( EA/SOO/Archive Archive "EA/SOO" )

shark_add_example( Supervised/MultiTaskSvm MultiTaskSvm "Supervised" )
shark_add_example( Supervised/DeepNetworkTraining DeepNetworkTraining "Supervised" )
shark_add_example( Supervised/DeepNetworkTrainingRBM DeepNetworkTrainingRBM "Supervised" )

shark_add_example( Supervised/CVFolds CVFolds "Supervised" )
shark_add_example( Supervised/CSvmLinear CSvmLinear "Supervised" )
shark_add_example( Supervised/McSvm McSvm "Supervised" )
shark_add_example( Supervised/McSvmLinear McSvmLinear "Supervised" )
shark_add_example( Supervised/KernelRegression KernelRegression "Supervised" )
shark_add_example( Supervised/KernelSelection KernelSelection "Supervised" )
shark_add_example( Supervised/OneVersusOne OneVersusOne "Supervised" )
shark_add_example( Supervised/KernelLogisticRegression KernelLogisticRegression "Supervised" )

shark_add_example( Supervised/CSvmMaxLikelihoodMS CSvmMaxLikelihoodMS "Supervised" )
shark_add_example( Supervised/CSvmGridSearchTutorial CSvmGridSearchTutorial "Supervised" )
shark_add_example( Supervised/CSvmTutorial CSvmTutorial "Supervised" )

shark_add_example( Supervised/MklKernelTutorial MklKernelTutorial "Supervised" )
shark_add_example( Supervised/SubrangeKernelTutorial SubrangeKernelTutorial "Supervised" )

shark_add_example( Supervised/KNNTutorial KNNTutorial "Supervised" )
shark_add_example( Supervised/LDATutorial LDATutorial "Supervised" )
shark_add_example( Supervised/elmTutorial elmTutorial "Supervised" )
shark_add_example( Supervised/KNNCrossValidationTutorial KNNCrossValidationTutorial "Supervised" )
shark_add_example( Supervised/linearRegressionTutorial linearRegressionTutorial "Supervised" )
shark_add_example( Supervised/LassoRegression LassoRegression "Supervised" )
shark_add_example( Supervised/FFNNBasicTutorial FFNNBasicTutorial "Supervised" )
shark_add_example( Supervised/FFNNMultiClassCrossEntropy FFNNMultiClassCrossEntropy "Supervised" )
shark_add_example( Supervised/RFTutorial RFTutorial "Supervised" )
shark_add_example( Supervised/CARTTutorial CARTTutorial "Supervised" )
shark_add_example( Supervised/KTA-tutorial KTA-tutorial "Supervised" )
shark_add_example( Supervised/VersatileClassificationTutorial-LDA VersatileClassificationTutorial-LDA "Supervised" )
shark_add_example( Supervised/VersatileClassificationTutorial-NN VersatileClassificationTutorial-NN "Supervised" )
shark_add_example( Supervised/VersatileClassificationTutorial-SVM VersatileClassificationTutorial-SVM "Supervised" )
shark_add_example( Supervised/VersatileClassificationTutorial-RF VersatileClassificationTutorial-RF "Supervised" )
shark_add_example( Supervised/VersatileClassificationTutorial-Network VersatileClassificationTutorial-Network "Supervised" )
shark_add_example( Supervised/KernelBudgetedSGDTutorial KernelBudgetedSGDTutorial "Supervised" )

#basic tutorials
shark_add_example( Supervised/quickstartTutorial quickstartTutorial "Supervised" )
shark_add_example( Supervised/regressionTutorial regressionTutorial "Supervised" )
shark_add_example( Supervised/StoppingCriteria StoppingCriteriaTutorial "Supervised" )

#Statistics
shark_add_example( Statistics/Statistics Statistics "Statistiscs" )

#Data
shark_add_example( Data/Datasets Datasets "Data" )
shark_add_example( Data/Normalization Normalization "Data" )
shark_add_example( Data/Subsets Subsets "Data" )

#Unsupervisd
shark_add_example( Unsupervised/PCA PCA "Unsupervised" )
shark_add_example( Unsupervised/PCATutorial PCATutorial "Unsupervised" )
shark_add_example( Unsupervised/KMeansTutorial KMeansTutorial "Unsupervised" )
shark_add_example( Unsupervised/MaxLogLikelihood MaxLogLikelihoodTutorial "Unsupervised" )
shark_add_example( Unsupervised/BinaryRBM BinaryRBM "Unsupervised" )
shark_add_example( Unsupervised/SparseAETutorial SparseAETutorial "Unsupervised" )
shark_add_example( Unsupervised/AutoEncoderTutorial AutoencoderTutorial "Unsupervised" )
shark_add_example( Unsupervised/DenoisingAutoencoderTutorial DenoisingAutoencoderTutorial "Unsupervised" )
shark_add_example( Unsupervised/HierarchicalClustering HierarchicalClustering "Unsupervised" )
shark_add_example( Unsupervised/OneClassSvm OneClassSvm "Unsupervised" )

add_custom_target(tpp2cpp DEPENDS ${TPP_FILES})

# Installation of the examples data
if( BUILD_EXAMPLES )
	install( DIRECTORY
		"${CMAKE_CURRENT_SOURCE_DIR}/Supervised/data"
		DESTINATION ${SHARK_INSTALL_EXAMPLE_DIR}/Supervised
		PATTERN ".*" EXCLUDE
	)

	install( DIRECTORY
		"${CMAKE_CURRENT_SOURCE_DIR}/Unsupervised/data"
		DESTINATION ${SHARK_INSTALL_EXAMPLE_DIR}/Unsupervised
		PATTERN ".*" EXCLUDE
	)
endif()

=== src/CMakeLists.txt ===
# Glob the files
file( GLOB_RECURSE SHARK_SRCS RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.cpp)
file(GLOB_RECURSE SHARK_HEADERS RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} ../include/*.h ../include/*.hpp ../include/*.inl)

# Group the source for MSVC
foreach(FILE ${SHARK_SRCS}) 
    # Get the directory of the source file
    get_filename_component(PARENT_DIR "${FILE}" PATH)
    # Make sure we are using windows slashes
    string(REPLACE "/" "\\" GROUP "${PARENT_DIR}")

    set(GROUP "src\\${GROUP}")

    source_group("${GROUP}" FILES "${FILE}")
endforeach()
#Also Group the Header Files
foreach(FILE ${SHARK_HEADERS}) 
    # Get the directory of the source file
    get_filename_component(PARENT_DIR "${FILE}" PATH)

	string(REPLACE "../" "" GROUP "${PARENT_DIR}")

    # Make sure we are using windows slashes
    string(REPLACE "/" "\\" GROUP "${GROUP}")

    source_group("${GROUP}" FILES "${FILE}")
endforeach()



# Create the shark library
add_library( shark ${SHARK_SRCS} ${SHARK_HEADERS} )
target_link_libraries( shark ${LINK_LIBRARIES})

set_target_properties( shark PROPERTIES DEBUG_POSTFIX _debug )

if( WIN32 )
  set_target_properties( shark PROPERTIES DEBUG_PREFIX ../ )
endif()

# Add the version executable
add_executable(SharkVersion Core/Version.cpp)
target_link_libraries(SharkVersion shark)

# Install the library
set_target_properties( shark PROPERTIES
	VERSION ${SHARK_VERSION}
	SOVERSION ${SHARK_SOVERSION})

install(TARGETS shark
	    EXPORT SharkTargets
	    RUNTIME DESTINATION bin
	    LIBRARY DESTINATION lib
	    ARCHIVE DESTINATION lib)
	
install(TARGETS SharkVersion
	    EXPORT SharkTargets
	    RUNTIME DESTINATION bin)

=== doc/tools/Makefile ===

all:
	g++ -O3 -DNDEBUG -o tut2rst tut2rst.cpp

clean:
	rm -f tut2rst

=== examples/ExampleProject/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

# This project is designed to be built outside the Shark source tree.
# set Shark_DIR to the proper location
project(ExampleProject)

# Find the Shark libraries and includes
find_package(Shark REQUIRED)
include(${SHARK_USE_FILE})

# Executable
add_executable(ExampleProject HelloWorld.cpp)
target_link_libraries(ExampleProject ${SHARK_LIBRARIES})

=== debian/control ===
Source: shark
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
Section: science
Testsuite: autopkgtest
Priority: optional
Build-Depends: cmake,
               debhelper (>= 9),
               libblas-dev | libblas.so,
               libboost-date-time-dev,
               libboost-filesystem-dev,
               libboost-program-options-dev,
               libboost-serialization-dev,
               libboost-system-dev,
               libboost-test-dev,
               libboost-thread-dev,
               libhdf5-dev
Build-Depends-Indep: doxygen,
                     graphviz,
                     python-sphinx
Standards-Version: 3.9.7
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/shark.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/shark.git
Homepage: http://image.diku.dk/shark

Package: libshark0
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Shark machine learning library
 Shark is a modular C++ library for the design and optimization of adaptive
 systems. It provides methods for linear and nonlinear optimization, in
 particular evolutionary and gradient-based algorithms, kernel-based learning
 algorithms and neural networks, and various other machine learning techniques.
 .
 This package provides the Shark library.

Package: libshark0-dbg
Architecture: any
Multi-Arch: same
Section: debug
Priority: extra
Depends: ${misc:Depends},
         libshark0 (= ${binary:Version})
Description: debugging symbols for Shark
 Shark is a modular C++ library for the design and optimization of adaptive
 systems. It provides methods for linear and nonlinear optimization, in
 particular evolutionary and gradient-based algorithms, kernel-based learning
 algorithms and neural networks, and various other machine learning techniques.
 .
 This package provides the debugging symbols for the Shark library.

Package: libshark-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         libblas-dev | libblas.so,
         libboost-dev,
         libhdf5-dev,
         libshark0 (= ${binary:Version})
Suggests: shark-doc
Description: development files for Shark
 Shark is a modular C++ library for the design and optimization of adaptive
 systems. It provides methods for linear and nonlinear optimization, in
 particular evolutionary and gradient-based algorithms, kernel-based learning
 algorithms and neural networks, and various other machine learning techniques.
 .
 This package provides the development files for the Shark library.

Package: shark-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends},
         ${sphinxdoc:Depends},
         libjs-mathjax
Description: documentation and examples for Shark
 Shark is a modular C++ library for the design and optimization of adaptive
 systems. It provides methods for linear and nonlinear optimization, in
 particular evolutionary and gradient-based algorithms, kernel-based learning
 algorithms and neural networks, and various other machine learning techniques.
 .
 This package provides the documentation and example source code for the Shark
 library.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE = 1

# Hardening flags.
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Wall -pedantic
export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# Environment information.
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# Common cmake options.
CMAKE_BUILD_OPTIONS = \
	-DBUILD_SHARED_LIBS=ON \
	-DENABLE_CBLAS=ON \
	-DENABLE_OPENMP=ON \
	-DSHARK_INSTALL_DOC_DIR=share/doc/shark-doc \
	-DSHARK_INSTALL_EXAMPLE_DIR=share/doc/shark-doc/examples

# Disable build of testsuite if no check requested.
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
CMAKE_BUILD_OPTIONS += -DBUILD_TESTING=ON
else
CMAKE_BUILD_OPTIONS += -DBUILD_TESTING=OFF
endif

%:
	dh $@ --parallel --dbg-package=libshark0-dbg

override_dh_auto_configure-arch:
	dh_auto_configure -- $(CMAKE_BUILD_OPTIONS) \
		-DBUILD_DOCUMENTATION=OFF \
		-DBUILD_EXAMPLES=OFF

override_dh_auto_configure-indep:
	dh_auto_configure -- $(CMAKE_BUILD_OPTIONS) \
		-DBUILD_DOCUMENTATION=ON \
		-DBUILD_EXAMPLES=ON \
		-DOPT_INSTALL_DOCUMENTATION=ON

override_dh_auto_test:
ifneq ($(DEB_HOST_ARCH),i386)
ifneq ($(DEB_HOST_ARCH),powerpc)
ifneq ($(DEB_HOST_ARCH),armhf)
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# Temporary override for buggy HDF5 testcase.
	# See https://github.com/Shark-ML/Shark/issues/43
	# Exclude HDF5 testcase from ctest.
	cd obj-* && \
	CTEST_OUTPUT_ON_FAILURE=1 \
	ctest --force-new-ctest-process -E "HDF5"
	# Run HDF5 test executable manually.
	cd obj-* && ./bin/Data_HDF5
endif
endif
endif
endif

override_dh_installdocs-indep:
	dh_installdocs --indep
	dh_doxygen --indep \
		/usr/share/doc/shark-doc/html/doxygen_pages/html
	dh_sphinxdoc --indep --exclude=MathJax.js \
		/usr/share/doc/shark-doc/html/sphinx_pages

override_dh_compress:
	dh_compress --exclude=examples

=== debian/tests/control ===
Tests: build-examples
Depends: build-essential,
         cmake,
         libboost-date-time-dev,
         libboost-filesystem-dev,
         libboost-program-options-dev,
         libboost-system-dev,
         libboost-test-dev,
         libboost-thread-dev,
         libshark-dev,
         pkg-config,
         shark-doc

## shark 3.1.0+ds1

=== CMakeLists.txt ===
--- 
+++ 
@@ -258,9 +258,21 @@
 		endif()
 		if(CBLAS_LIB_PATH)
 			find_file(CBLAS_INCLUDES cblas.h 
-				PATHS ${CBLAS_LIB_PATH} ${CBLAS_LIB_PATH}/../include ${CBLAS_LIB_PATH}/../../include/atlas
+				PATHS ${CBLAS_LIB_PATH} ${CBLAS_LIB_PATH}/../include
 			)
 			get_filename_component(CBLAS_INCLUDES ${CBLAS_INCLUDES} PATH )
+		endif()
+		if(ATLAS_LIBRARY)
+			get_filename_component(ATLAS_LIBRARY_PATH ${ATLAS_LIBRARY} PATH )
+			find_file(CLAPACK_INCLUDES clapack.h 
+				PATHS
+				${ATLAS_LIBRARY_PATH} 
+				${ATLAS_LIBRARY_PATH}/../include
+				${ATLAS_LIBRARY_PATH}/../include/atlas
+				${ATLAS_LIBRARY_PATH}/../../include/atlas
+			)
+			get_filename_component(CLAPACK_INCLUDES ${CLAPACK_INCLUDES} PATH )
+			set(CBLAS_INCLUDES ${CBLAS_INCLUDES} ${CLAPACK_INCLUDES})
 		endif()
 
 		if( OPENBLAS_LIBRARY AND CBLAS_INCLUDES)
@@ -315,13 +327,3 @@
 #####################################################################
 #                       Static Code Analysis
 #####################################################################
-option(USE_CPPCHECK "Use CPPCheck Static Code Analysis" OFF)
-mark_as_advanced(USE_CPPCHECK)
-if(USE_CPPCHECK)
-	find_program(CPP_CHECK cppcheck)
-	mark_as_advanced(CPP_CHECK)
-if(CPP_CHECK)
-	message(STATUS "cppcheck available for static code analysis." )
-	add_custom_target(code_analysis
-		${CPP_CHECK} --enable=all --xml --force -I${CMAKE_CURRENT_SOURCE_DIR}/include ${CMAKE_CURRENT_SOURCE_DIR} 2> StaticAnalysis.xml)
-	endif()

=== Test/CMakeLists.txt ===
--- 
+++ 
@@ -80,10 +80,12 @@
 shark_add_test( Algorithms/DirectSearch/CMA.cpp DirectSearch_CMA )
 shark_add_test( Algorithms/DirectSearch/CMSA.cpp DirectSearch_CMSA )
 shark_add_test( Algorithms/DirectSearch/ElitistCMA.cpp DirectSearch_ElitistCMA )
+shark_add_test( Algorithms/DirectSearch/CrossEntropyMethod.cpp DirectSearch_CrossEntropyMethod )
 shark_add_test( Algorithms/DirectSearch/VDCMA.cpp DirectSearch_VDCMA )
 shark_add_test( Algorithms/DirectSearch/MOCMA.cpp DirectSearch_MOCMA )
 shark_add_test( Algorithms/DirectSearch/SteadyStateMOCMA.cpp DirectSearch_SteadyStateMOCMA )
 shark_add_test( Algorithms/DirectSearch/RealCodedNSGAII.cpp DirectSearch_RealCodedNSGAII )
+shark_add_test( Algorithms/DirectSearch/SMS-EMOA.cpp DirectSearch_SMS-EMOA )
 shark_add_test( Algorithms/DirectSearch/FastNonDominatedSort.cpp DirectSearch_FastNonDominatedSort )
 shark_add_test( Algorithms/DirectSearch/ParetoDominanceComparator.cpp DirectSearch_ParetoDominanceComparator )
 
@@ -206,4 +208,3 @@
 
 #Objective Functions
 shark_add_test( ObjectiveFunctions/ErrorFunction.cpp ObjFunct_ErrorFunction )
-shark_add_test( ObjectiveFunctions/SparseAutoencoderError.cpp ObjFunct_SparseAutoencoderError )

=== debian/changelog ===
shark (3.1.0+ds1-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patch queue.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Wed, 23 Mar 2016 11:26:27 +0000

=== debian/rules ===
--- 
+++ 
@@ -41,9 +41,6 @@
 		-DOPT_INSTALL_DOCUMENTATION=ON
 
 override_dh_auto_test:
-ifneq ($(DEB_HOST_ARCH),i386)
-ifneq ($(DEB_HOST_ARCH),powerpc)
-ifneq ($(DEB_HOST_ARCH),armhf)
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	# Temporary override for buggy HDF5 testcase.
 	# See https://github.com/Shark-ML/Shark/issues/43
@@ -53,9 +50,6 @@
 	ctest --force-new-ctest-process -E "HDF5"
 	# Run HDF5 test executable manually.
 	cd obj-* && ./bin/Data_HDF5
-endif
-endif
-endif
 endif
 
 override_dh_installdocs-indep:

## shark 3.1.1+ds1

=== debian/changelog ===
shark (3.1.1+ds1-1) unstable; urgency=medium

  * New upstream release.
  * Bump standards version to 3.9.8, no changes required.
  * Cherry-pick patch series fixing FTBFS on Stretch. (Closes: #831121)
  * Cherry-pick patch series fixing FTBFS of the testsuite. (Closes: #820701)
  * Remove test target override, no longer necessary.
  * Drop debug package in favor of autogenerated dbgsym.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Sun, 21 Aug 2016 17:37:51 +0100

=== debian/control ===
--- 
+++ 
@@ -18,7 +18,7 @@
 Build-Depends-Indep: doxygen,
                      graphviz,
                      python-sphinx
-Standards-Version: 3.9.7
+Standards-Version: 3.9.8
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/shark.git
 Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/shark.git
 Homepage: http://image.diku.dk/shark
@@ -37,21 +37,6 @@
  algorithms and neural networks, and various other machine learning techniques.
  .
  This package provides the Shark library.
-
-Package: libshark0-dbg
-Architecture: any
-Multi-Arch: same
-Section: debug
-Priority: extra
-Depends: ${misc:Depends},
-         libshark0 (= ${binary:Version})
-Description: debugging symbols for Shark
- Shark is a modular C++ library for the design and optimization of adaptive
- systems. It provides methods for linear and nonlinear optimization, in
- particular evolutionary and gradient-based algorithms, kernel-based learning
- algorithms and neural networks, and various other machine learning techniques.
- .
- This package provides the debugging symbols for the Shark library.
 
 Package: libshark-dev
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -27,7 +27,7 @@
 endif
 
 %:
-	dh $@ --parallel --dbg-package=libshark0-dbg
+	dh $@ --parallel
 
 override_dh_auto_configure-arch:
 	dh_auto_configure -- $(CMAKE_BUILD_OPTIONS) \
@@ -40,18 +40,6 @@
 		-DBUILD_EXAMPLES=ON \
 		-DOPT_INSTALL_DOCUMENTATION=ON
 
-override_dh_auto_test:
-ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
-	# Temporary override for buggy HDF5 testcase.
-	# See https://github.com/Shark-ML/Shark/issues/43
-	# Exclude HDF5 testcase from ctest.
-	cd obj-* && \
-	CTEST_OUTPUT_ON_FAILURE=1 \
-	ctest --force-new-ctest-process -E "HDF5"
-	# Run HDF5 test executable manually.
-	cd obj-* && ./bin/Data_HDF5
-endif
-
 override_dh_installdocs-indep:
 	dh_installdocs --indep
 	dh_doxygen --indep \
